{ Created: 2000-04-18 by Berend  (c) 2000 by Ortec

Can hold a stack of strings. Be aware, this stack is written according to
the Command/Query Separation principle!

Bugs:
- assume Latin 1 code page is in effect...

}


unit string_stack;

interface

const
  MaxStringStackSize = 256;

type
  TStringStack = class
  protected
    FStack: array[0..MaxStringStackSize-1] of WideString;
    FStackCount: Integer;
  public
    Top: WideString;
      { contains the top entry of the stack }

    procedure Clear;
      { remove all entries from the stack }

    property Count: Integer read FStackCount;
      { the number of entries on the stack }

    function  IsEmpty: Boolean;
      { true if stack doesn't contain items }

    procedure Pop;

    procedure Push(const s: WideString);
  end;


implementation


{ TStringStack }

procedure TStringStack.Clear;
begin
  FStackCount := 0;

{ensure}
  Assert(IsEmpty, 'ensure: stack is empty now.');
end;


function TStringStack.IsEmpty: Boolean;
begin
  Result := FStackCount = 0;
end;


procedure TStringStack.Pop;
begin
{require}
  Assert(not IsEmpty, 'require: stack should not be empty.');
  
  FStackCount := FStackCount - 1;
  if FStackCount = 0 then
  begin
    Top := '';
  end
  else
  begin
    Top := FStack[FStackCount-1];
  end;
end;


procedure TStringStack.Push(const s: WideString);
begin
{require}
  Assert(FStackCount < MaxStringStackSize, 'require: stack has room for entries.');

  if FStackCount > 0 then
    FStack[FStackCount-1] := Top;
  FStackCount := FStackCount + 1;
  Top := s;

{ensure}
  Assert(not IsEmpty, 'ensure: stack is not empty anymore.');
end;


end.
